sampler sampler0_ : register(s0);

texture texLayer_;
sampler sampler1_ = sampler_state {
	Texture = <texLayer_>;
};

struct PS_INPUT
{
	float4 diffuse : COLOR0;
	float2 texCoord : TEXCOORD0;
	float2 vPos : VPOS;
};

struct PS_OUTPUT
{
	float4 color : COLOR0;
};

float2 iResolution;
float2 tPos;
float strength = 1;

float3 eraseColor = float3(-1,-1,-1);

PS_OUTPUT PsRender( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;

	float2 uv;
		uv.x = In.texCoord.x;
		uv.y = In.texCoord.y;

	float2 uvMod;
		uvMod.x = In.texCoord.x + tPos.x;
		uvMod.y = In.texCoord.y + tPos.y;

	float4 color1 = tex2D(sampler1_, uvMod);
	float value = ((color1.r + color1.g + color1.b) * 0.3333f - 0.5f) * 2.0f;

	uv.x += (value/iResolution.x)*strength;
	uv.y += (value/iResolution.y)*strength;

	float4 color0 = tex2D(sampler0_, uv);
	color0 *= In.diffuse;

	Out.color = color0;

	return Out;
}

technique Render
{
	pass P0
	{
		PixelShader = compile ps_3_0 PsRender();
	}
}

