sampler s0_ : register( s0 );

texture s1_t;
sampler s1_ = sampler_state{
	Texture = <s1_t>;
};

struct PS_INPUT
{
	float4 diffuse	: COLOR0;
	float2 texCoord	: TEXCOORD0;
	float2 vPos	: VPOS;
};

struct PS_OUTPUT
{
	float4 color	: COLOR0;
};

float xStrength = 0;
float yStrength = 0;

float2 nX = float2(0,0);
float2 nY = float2(0,0);

float xOff = 0;
float yOff = 0;

float2 iResolution = float2(2048,1024);

float rand(float x, float y)
{
	float2 uv = float2(x,y);
	float2 noise = (frac(sin(dot(uv ,float2(12.9898,78.233)*2.0)) * 43758.5453));
	return abs(noise.x + noise.y) * 0.5-0.5;
}

PS_OUTPUT PS( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;

	float4 noiseTexture1 = tex2D(s1_, float2(In.texCoord.x + nX.x / 1024, In.texCoord.y + nY.x / 1024));
	float4 noise1 = noiseTexture1;

	float noiseA1 = (noise1.r + noise1.g + noise1.b) * 0.3333f;
	noiseA1 *= 2;
	noiseA1 -= 1;

	float4 noiseTexture2 = tex2D(s1_, float2(In.texCoord.x + nX.y / 1024, In.texCoord.y + nY.y / 1024));
	float4 noise2 = noiseTexture2;

	float noiseA2 = (noise2.r + noise2.g + noise2.b) * 0.3333f;
	noiseA2 *= 2;
	noiseA2 -= 1;

	float xOffset = noiseA1 + xOff;
	float yOffset = noiseA2 + yOff;

	float2 uv;
		uv.x = In.texCoord.x;
		uv.y = In.texCoord.y;

	uv.x += (xStrength * xOffset) / iResolution.x;
	uv.y += (yStrength * yOffset) / iResolution.y;

	float4 colorTexture = tex2D(s0_, uv);
	float4 colorDiffuse = In.diffuse;
	float4 color = colorTexture * colorDiffuse;

	Out.color = color;

	return Out;
}

technique Render
{
	pass P0
	{
		PixelShader = compile ps_3_0 PS();
	}
}

